<center><a href="seq.c">Actual source code: seq.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:27:15+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* seq.f -- translated by f2c (version of 25 March 1992  12:58:56).*/</font>

<a name="line5"> 5: </a> #include <A href="../../../include/petsc.h.html">petsc.h</A>
<a name="line6"> 6: </a> #include <A href="../../../src/mat/color/color.h.html">src/mat/color/color.h</A>

<a name="line10"> 10: </a><strong><font color="#4169E1"><a name="MINPACKseq"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MINPACKseq(<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *indrow,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *jpntr,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *indcol,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ipntr,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *list,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ngrp,</font></strong>
<a name="line11"> 11: </a><strong><font color="#4169E1">                          <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *maxgrp,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *iwa)</font></strong>
<a name="line12"> 12: </a>{
<a name="line13"> 13: </a>    <font color="#B22222">/* System generated locals */</font>
<a name="line14"> 14: </a>    <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i__1, i__2, i__3;

<a name="line16"> 16: </a>    <font color="#B22222">/* Local variables */</font>
<a name="line17"> 17: </a>    <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> jcol, j, ic, ip, jp, ir;

<a name="line19"> 19: </a><font color="#B22222">/*     Given the sparsity pattern of an m by n matrix A, this */</font>
<a name="line20"> 20: </a><font color="#B22222">/*     subroutine determines a consistent partition of the */</font>
<a name="line21"> 21: </a><font color="#B22222">/*     columns of A by a sequential algorithm. */</font>
<a name="line22"> 22: </a><font color="#B22222">/*     A consistent partition is defined in terms of the loopless */</font>
<a name="line23"> 23: </a><font color="#B22222">/*     graph G with vertices a(j), j = 1,2,...,n where a(j) is the */</font>
<a name="line24"> 24: </a><font color="#B22222">/*     j-th column of A and with edge (a(i),a(j)) if and only if */</font>
<a name="line25"> 25: </a><font color="#B22222">/*     columns i and j have a non-zero in the same row position. */</font>
<a name="line26"> 26: </a><font color="#B22222">/*     A partition of the columns of A into groups is consistent */</font>
<a name="line27"> 27: </a><font color="#B22222">/*     if the columns in any group are not adjacent in the graph G. */</font>
<a name="line28"> 28: </a><font color="#B22222">/*     In graph-theory terminology, a consistent partition of the */</font>
<a name="line29"> 29: </a><font color="#B22222">/*     columns of A corresponds to a coloring of the graph G. */</font>
<a name="line30"> 30: </a><font color="#B22222">/*     The subroutine examines the columns in the order specified */</font>
<a name="line31"> 31: </a><font color="#B22222">/*     by the array list, and assigns the current column to the */</font>
<a name="line32"> 32: </a><font color="#B22222">/*     group with the smallest possible number. */</font>
<a name="line33"> 33: </a><font color="#B22222">/*     Note that the value of m is not needed by seq and is */</font>
<a name="line34"> 34: </a><font color="#B22222">/*     therefore not present in the subroutine statement. */</font>
<a name="line35"> 35: </a><font color="#B22222">/*     The subroutine statement is */</font>
<a name="line36"> 36: </a><font color="#B22222">/*       subroutine seq(n,indrow,jpntr,indcol,ipntr,list,ngrp,maxgrp, */</font>
<a name="line37"> 37: </a><font color="#B22222">/*                      iwa) */</font>
<a name="line38"> 38: </a><font color="#B22222">/*     where */</font>
<a name="line39"> 39: </a><font color="#B22222">/*       n is a positive integer input variable set to the number */</font>
<a name="line40"> 40: </a><font color="#B22222">/*         of columns of A. */</font>
<a name="line41"> 41: </a><font color="#B22222">/*       indrow is an integer input array which contains the row */</font>
<a name="line42"> 42: </a><font color="#B22222">/*         indices for the non-zeroes in the matrix A. */</font>
<a name="line43"> 43: </a><font color="#B22222">/*       jpntr is an integer input array of length n + 1 which */</font>
<a name="line44"> 44: </a><font color="#B22222">/*         specifies the locations of the row indices in indrow. */</font>
<a name="line45"> 45: </a><font color="#B22222">/*         The row indices for column j are */</font>
<a name="line46"> 46: </a><font color="#B22222">/*               indrow(k), k = jpntr(j),...,jpntr(j+1)-1. */</font>
<a name="line47"> 47: </a><font color="#B22222">/*         Note that jpntr(n+1)-1 is then the number of non-zero */</font>
<a name="line48"> 48: </a><font color="#B22222">/*         elements of the matrix A. */</font>
<a name="line49"> 49: </a><font color="#B22222">/*       indcol is an integer input array which contains the */</font>
<a name="line50"> 50: </a><font color="#B22222">/*         column indices for the non-zeroes in the matrix A. */</font>
<a name="line51"> 51: </a><font color="#B22222">/*       ipntr is an integer input array of length m + 1 which */</font>
<a name="line52"> 52: </a><font color="#B22222">/*         specifies the locations of the column indices in indcol. */</font>
<a name="line53"> 53: </a><font color="#B22222">/*         The column indices for row i are */</font>
<a name="line54"> 54: </a><font color="#B22222">/*               indcol(k), k = ipntr(i),...,ipntr(i+1)-1. */</font>
<a name="line55"> 55: </a><font color="#B22222">/*         Note that ipntr(m+1)-1 is then the number of non-zero */</font>
<a name="line56"> 56: </a><font color="#B22222">/*         elements of the matrix A. */</font>
<a name="line57"> 57: </a><font color="#B22222">/*       list is an integer input array of length n which specifies */</font>
<a name="line58"> 58: </a><font color="#B22222">/*         the order to be used by the sequential algorithm. */</font>
<a name="line59"> 59: </a><font color="#B22222">/*         The j-th column in this order is list(j). */</font>
<a name="line60"> 60: </a><font color="#B22222">/*       ngrp is an integer output array of length n which specifies */</font>
<a name="line61"> 61: </a><font color="#B22222">/*         the partition of the columns of A. Column jcol belongs */</font>
<a name="line62"> 62: </a><font color="#B22222">/*         to group ngrp(jcol). */</font>
<a name="line63"> 63: </a><font color="#B22222">/*       maxgrp is an integer output variable which specifies the */</font>
<a name="line64"> 64: </a><font color="#B22222">/*         number of groups in the partition of the columns of A. */</font>
<a name="line65"> 65: </a><font color="#B22222">/*       iwa is an integer work array of length n. */</font>
<a name="line66"> 66: </a><font color="#B22222">/*     Argonne National Laboratory. MINPACK Project. July 1983. */</font>
<a name="line67"> 67: </a><font color="#B22222">/*     Thomas F. Coleman, Burton S. Garbow, Jorge J. More' */</font>

<a name="line70"> 70: </a>    <font color="#B22222">/* Parameter adjustments */</font>
<a name="line71"> 71: </a>    --iwa;
<a name="line72"> 72: </a>    --ngrp;
<a name="line73"> 73: </a>    --list;
<a name="line74"> 74: </a>    --ipntr;
<a name="line75"> 75: </a>    --indcol;
<a name="line76"> 76: </a>    --jpntr;
<a name="line77"> 77: </a>    --indrow;

<a name="line79"> 79: </a>    <font color="#B22222">/* Function Body */</font>
<a name="line80"> 80: </a>    *maxgrp = 0;
<a name="line81"> 81: </a>    i__1 = *n;
<a name="line82"> 82: </a>    <font color="#4169E1">for</font> (jp = 1; jp &lt;= i__1; ++jp) {
<a name="line83"> 83: </a>        ngrp[jp] = *n;
<a name="line84"> 84: </a>        iwa[jp] = 0;
<a name="line85"> 85: </a>    }

<a name="line87"> 87: </a>    <font color="#B22222">/*     Beginning of iteration loop. */</font>

<a name="line89"> 89: </a>    i__1 = *n;
<a name="line90"> 90: </a>    <font color="#4169E1">for</font> (j = 1; j &lt;= i__1; ++j) {
<a name="line91"> 91: </a>        jcol = list[j];

<a name="line93"> 93: </a>        <font color="#B22222">/*        Find all columns adjacent to column jcol. */</font>

<a name="line95"> 95: </a>        <font color="#B22222">/*        Determine all positions (ir,jcol) which correspond */</font>
<a name="line96"> 96: </a>        <font color="#B22222">/*        to non-zeroes in the matrix. */</font>

<a name="line98"> 98: </a>        i__2 = jpntr[jcol + 1] - 1;
<a name="line99"> 99: </a>        <font color="#4169E1">for</font> (jp = jpntr[jcol]; jp &lt;= i__2; ++jp) {
<a name="line100">100: </a>            ir = indrow[jp];

<a name="line102">102: </a>            <font color="#B22222">/*           For each row ir, determine all positions (ir,ic) */</font>
<a name="line103">103: </a>            <font color="#B22222">/*           which correspond to non-zeroes in the matrix. */</font>

<a name="line105">105: </a>            i__3 = ipntr[ir + 1] - 1;
<a name="line106">106: </a>            <font color="#4169E1">for</font> (ip = ipntr[ir]; ip &lt;= i__3; ++ip) {
<a name="line107">107: </a>                ic = indcol[ip];

<a name="line109">109: </a>                <font color="#B22222">/*              Array iwa marks the group numbers of the */</font>
<a name="line110">110: </a>                <font color="#B22222">/*              columns which are adjacent to column jcol. */</font>

<a name="line112">112: </a>                iwa[ngrp[ic]] = j;
<a name="line113">113: </a>            }
<a name="line114">114: </a>        }

<a name="line116">116: </a>        <font color="#B22222">/*        Assign the smallest un-marked group number to jcol. */</font>

<a name="line118">118: </a>        i__2 = *maxgrp;
<a name="line119">119: </a>        <font color="#4169E1">for</font> (jp = 1; jp &lt;= i__2; ++jp) {
<a name="line120">120: </a>            <font color="#4169E1">if</font> (iwa[jp] != j) {
<a name="line121">121: </a>                <font color="#4169E1">goto</font> L50;
<a name="line122">122: </a>            }
<a name="line123">123: </a>        }
<a name="line124">124: </a>        ++(*maxgrp);
<a name="line125">125: </a><strong><font color="#FF0000">L50:</font></strong>
<a name="line126">126: </a>        ngrp[jcol] = jp;
<a name="line127">127: </a>    }

<a name="line129">129: </a>    <font color="#B22222">/*        End of iteration loop. */</font>

<a name="line131">131: </a>    <font color="#4169E1">return</font>(0);
<a name="line132">132: </a>}

</pre>
</body>

</html>
